#include <string>
#include <vector>
#include <iostream>
#include <iomanip>
#include "hipdefs.h"

static inline void print(int rank, const std::string &str) {
    std::cout << "rank=" << rank << ": " << str << std::endl;	
}

void device_affinity(int rank) {
    int devid = 0;
    HIP_CALL(hipGetDevice(&devid));
    print(rank, std::string("devid: ") + std::to_string(devid));
    hipDeviceProp_t props;
    memset(&props, 0, sizeof(props));
    HIP_CALL(hipGetDeviceProperties(&props, devid));	
    int pciId = props.pciDeviceID;
    int vendorId = (pciId >> 16) & 0xFFFF;
    int deviceId = pciId & 0xFFFF;
    std::stringstream ss;
    ss << std::hex << std::setw(4) << std::setfill('0') << vendorId
       << ":" << std::hex << std::setw(4) << std::setfill('0') << deviceId;
    print(rank, ss.str());
}
